; --------------------------------------------------------------
; The BIOS will load the boot sector at 0000:7C00 and pass
; control to it. Some BIOSs may look for a near or far jump
; at the start of the sector. At least originally, BIOSs
; looked for the 55h,AAh signature at the end of the sector.
;
; Assemble (with MASM6+) "ml /c BOOTCODE.ASM"
; Link with "link16 /tiny BOOTCODE.OBJ,BOOTCODE.BIN;"
; (Ignore the start address warning)
; -------------------------------------------------------------- 
.386
_SEG segment use16
    assume ds:_SEG,es:_SEG,ss:_SEG
    ORG   7c00h
  entry:
    jmp   @F
  @@:    
    mov   si, 7c00h
    push  si
    pop   di
    push  9000h
    pop   es
    mov   cx, 512
    cld
    rep   movsb
    push  es
    push  OFFSET dest
    retf
  dest:
    xor   ax, ax    
    mov   ss, ax
    mov   sp, 7C00h
    mov   ds, ax
    mov   es, ax
    mov   si, OFFSET msg
    call  print
  @@:
    jmp   @B    ; Dynamic halt
  print:
    mov   ah, 0Eh
    xor   bx, bx
  @@:
    lodsb
    or    al, al
    jz    @F
    int   10h
    jmp   @B
@@:
    ret

    msg   db 13,10,13,10,"HELLO WORLD",0

    org   7C00h + 510
    db    55h,0AAh

_SEG ends
    end   entry

